/*
 * Downloaded from lenkaspace.net
 * 
 * Paper about this project: http://lenkaspace.net/papers/iteratedPrisonersDilemmaNeuralNetworks.php
 * Email: contact@lenkaspace.net
 */

package net.lenkaspace.prisonersnorecognition;

import java.util.Random;



public class Maths {
	private static Maths ref;
	
	private Maths() 	{
		
	}
	
	public static Maths getSingletonObject()	  {
		  if (ref == null)
		        // it's ok, we can call this constructor
		     ref = new Maths();		
		  return ref;
	}
	
	
	public double getRandomDouble(boolean inclZero) {
	    double aStart = 0.0;
	   
	    double aEnd = 10.0;
		if ( aStart > aEnd ) {
	      throw new IllegalArgumentException("Start cannot exceed End.");
	    }
	    //get the range, casting to long to avoid overflow problems
	    long range = (long)aEnd - (long)aStart + 1;
	    // compute a fraction of the range, 0 <= frac < range
	    long fraction = (long)(range * Math.random());
	    int randomNumber =  (int)(fraction + aStart); 
	    if (inclZero) {
	    	return (double)randomNumber/10;
	    } else {
	    	return (double)randomNumber/10 + 0.0001;
	    }
	    
	    
	}
	
	
	public int getRandomInteger(int aStart, int aEnd) {
	    //aEnd -= 1;
	    //aStart *=100;
	    //aEnd *= 100;
		if ( aStart > aEnd ) {
	      throw new IllegalArgumentException("Start cannot exceed End.");
	    }
	    //get the range, casting to long to avoid overflow problems
	    long range = (long)aEnd - (long)aStart + 1;
	    // compute a fraction of the range, 0 <= frac < range
	    long fraction = (long)(range * Math.random());
	    int randomNumber =  (int)((fraction + aStart)); 
	    return randomNumber;
	    
	}
	
	public double getRandomGaussian (double mean, double variance) {
		Random rand = new Random();
		return (mean + rand.nextGaussian()*variance);
	}
	
	
	
		
}
