/*
 * Downloaded from lenkaspace.net
 * 
 * Paper about this project: http://lenkaspace.net/papers/iteratedPrisonersDilemmaNeuralNetworks.php
 * Email: contact@lenkaspace.net
 */

package net.lenkaspace.prisonersnorecognition;

public class Settings
{
	
	private static Settings ref;
	private boolean mInitDone;
	private boolean mTimeRunning;
	//private boolean mSimulationRunning;
	private int		mSimulationType;
	
	public static final int WINDOW_W = 1120;
	public static final int WINDOW_H = 600;
	
	private Settings() 	{
		setInitDone(false);
	}
	
	public static Settings getSingletonObject()	  {
	  if (ref == null)
	        // it's ok, we can call this constructor
	     ref = new Settings();		
	  return ref;
	}
	
	public Object clone() throws CloneNotSupportedException {
	    throw new CloneNotSupportedException(); 
	}

	public void setInitDone(boolean mInitDone) {
		this.mInitDone = mInitDone;
	}

	public boolean getInitDone() {
		return mInitDone;
	}

	public void setTimeRunning(boolean mTimeRunning) {
		this.mTimeRunning = mTimeRunning;
	}

	public boolean getTimeRunning() {
		return mTimeRunning;
	}

	public void setSimulationType(int mSimulationType) {
		this.mSimulationType = mSimulationType;
	}

	public int getSimulationType() {
		return mSimulationType;
	}

	
}
